const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const uoms = sequelize.define(
    'uoms',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

symbol: {
        type: DataTypes.TEXT,
      
      

      },

type: {
        type: DataTypes.ENUM,
      
      

        values: [

"count",


"weight",


"volume",


"length",


"time",


"area"

        ],

      },

base_factor: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  uoms.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.uoms.hasMany(db.items, {
      as: 'items_uom',
      foreignKey: {
          name: 'uomId',
      },
      constraints: false,
    });


































//end loop






    db.uoms.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.uoms.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return uoms;
};


